#include <stdio.h>
#include <stdlib.h>
#include <libspe2.h>
#include <pthread.h> 

#define SPE_BIN "crypt"

void *
ppu_pthread_function(void *arg)
{
    spe_context_ptr_t context = *(spe_context_ptr_t *)arg;
    unsigned int entry = SPE_DEFAULT_ENTRY;
    spe_stop_info_t stop_info; 

    spe_context_run(context, &entry, 0, NULL, NULL, &stop_info);

    pthread_exit(NULL); 
} 



int
main()
{ 
    spe_program_handle_t *program;

    spe_context_ptr_t context;

    int flags = 0; 
    pthread_t pthread; 

    context = spe_context_create(flags, NULL); 

    program = spe_image_open(SPE_BIN);

    spe_program_load(context, program); 

    pthread_create(&pthread, NULL, &ppu_pthread_function, &context); 
    pthread_join(pthread, NULL); 

    spe_context_destroy(context); 

    return 0;
}
